﻿Public MustInherit Class Person
#Region "Variables"
    Private mName As String
    Private mBirthDate As Date
#End Region

#Region "Constructors"
    Public Sub New()
        Debug.WriteLine("Person constructor")
    End Sub
#End Region

#Region "Properties"
    Public Overridable Property Name As String
        Get
            Return mName
        End Get
        Set(value As String)
            mName = value
        End Set
    End Property

    Public Overridable Property BirthDate As Date
        Get
            Return mBirthDate
        End Get
        Set(value As Date)
            mBirthDate = value
        End Set
    End Property

    Public ReadOnly Property Age As Integer
        Get
            Return DateDiff(DateInterval.Year, Now, BirthDate)  'error!!!
        End Get
    End Property
#End Region

#Region "Methods"
    Public Overrides Function ToString() As String
        Return Me.Name
    End Function
#End Region

End Class
