﻿Module Module1

    Sub Main()
        Dim myFriends As New List(Of Person) _
            From {New Person With {.Name = "Suzie", .Age = 16},
                  New Person With {.Name = "Jack", .Age = 19}}

        'Lambda Expression for Action Delegate:
        'myFriends.ForEach(Sub(p As Person)
        '                      Console.WriteLine(p.ToString)
        '                  End Sub)

        'single line Lambda Expression for Action Delegate:
        myFriends.ForEach(Sub(p As Person) Console.WriteLine(p.ToString))

        Console.WriteLine(vbCrLf & "Done.")
        Console.ReadLine()
    End Sub

    Class Person
        Public Property Name As String
        Public Property Age As Integer

        Public Overrides Function ToString() As String
            Return Me.Name & " is " & Me.Age & " years old."
        End Function
    End Class

End Module

