'NICHT FERTIG

Imports System.IO
Imports System.Text

Public Class Form1

    Private isDirty As Boolean = False 'true if converted text in memory is not yet saved to disc
    Private mFilename As String

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        'create an open file dialog and preset the input filename
        Dim dlg As New OpenFileDialog()
        With dlg
            .Filter = "Text (*.txt)|*.txt"
            .FileName = "myDataInput.txt"
        End With
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            mFilename = dlg.FileName                        'remember the filename for later SAVE operation

            'jetzt knnte man so vorgehen:
            'Dim myInputStream As Stream = dlg.OpenFile()    'open the file readonly and obtain a stream to it
            'If Not (myInputStream Is Nothing) Then          'if the file exists
            '    Dim reader As New StreamReader(myInputStream)   'set up a reader for string IO
            '    Dim outString As String = ""
            '    Do Until reader.Peek = -1                       'check for EOF
            '        outString &= reader.ReadLine() & vbCrLf     'read a text line and append it to all previous lines
            '    Loop
            '    txtInput.Text = outString                       'output everything to the multiline textbox
            '    isDirty = True                                  'flag that we have read in data

            '    myInputStream.Close()
            '    myInputStream.Dispose()
            'Else
            '    MessageBox.Show("Cannot open input file.", "Error", MessageBoxButtons.OK)
            'End If

            'krzer geht's fr VB.NET Programmierer so:
            Dim outString As String = My.Computer.FileSystem.ReadAllText(mFilename)
            txtInput.Text = outString                       'output everything to the multiline textbox
            isDirty = True                                  'flag that we have read in data

            'jetzt haben wir den Text zwar am Bildschirm, aber wir wollen ja mit einem ByteStream arbeiten.
            'also knnten wir jetzt den String outString in ein Byte Array umwandeln, dieses dann in einen 
            'MemoryStream schreiben und von dort dann weiter verarbeiten.
            'Einfacher ist es, wenn wir den InputStream direkt in einen MemoryStream schreiben.
            Dim inputStream As New FileStream(mFilename, FileMode.Open, FileAccess.Read, FileShare.None)
            Dim outputStream As New FileStream("output.txt", FileMode.Create, FileAccess.Write, FileShare.None)

        End If
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Call Save()
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Call SaveAs()
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If isDirty Then
            If MessageBox.Show("The output data is not yet saved to disc. Do you really want to exit?", "Exit", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.No Then
                e.Cancel = True
            End If
        End If
    End Sub

    Private Function Save() As Boolean
        If mFilename Is Nothing Then                                'do we have a filename?
            Return SaveAs()                                         'if not, ask for the filename
        Else
            Dim myOutputStream As Stream
            myOutputStream = File.OpenWrite(mFilename)                    'open the file for write
            If Not (myOutputStream Is Nothing) Then


                myOutputStream.Close()                                    'close the file
                myOutputStream.Dispose()
                Return True
            Else
                Return False
            End If
        End If
    End Function

    Private Function SaveAs() As Boolean
        Dim saveFileDialog As New SaveFileDialog
        saveFileDialog.FileName = "myDataOutput.txt"
        If saveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            mFilename = saveFileDialog.FileName
            Return Save()
        End If
        Return False
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MessageBox.Show("Let's pretend that we work only with raw 8-bit bytes." & vbCrLf & "This is entirely reasonable, when working with single-byte character encoded text (eg. ASCII)." & vbCrLf & "Otherwise characters span multiple bytes making translation a lot more complicated.", "Warning", MessageBoxButtons.OK)
    End Sub
End Class
