﻿'This sample uses the WebClient class' stream interface to download a complete web page.
'note that some web servers dedect that they are accessed from a computer and do not return data.

Imports System
Imports System.IO
Imports System.Net

Module Module1

    Sub Main()
        Dim siteURL As String = "http://www.microsoft.com"
        Dim fileName As String = "C:\Temp\Microsoft.htm"
        Try
            'create new WebClient instance
            Dim client As New Net.WebClient()

            'concatenate the domain with the Web Resource filename
            Console.WriteLine("Start downloading data from {0}", siteURL)

            'download the Web resource from the remoteURL
            Dim stmData As Stream = client.OpenRead(siteURL)
            Dim sr As New StreamReader(stmData)

            'create file
            Dim fi As New FileInfo(fileName)
            Dim sw As StreamWriter = fi.CreateText()
            Console.WriteLine("Writing to the file " & fileName)

            'write to file
            sw.WriteLine(sr.ReadToEnd())
            sw.Flush()
            sw.Close()
            stmData.Close()

            Console.WriteLine("Done! Hit Enter to exit.")
            Console.ReadLine()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try
    End Sub

End Module
