﻿Imports System.Xml.Linq

Module Module1

    Sub Main()
        Try
            'load the XML file and store it in an XDocument object
            Dim xmlDoc = XDocument.Load("mycars.xml")

            'display the XML file declaration info
            'Console.WriteLine("Document declaration: {0}", xmlDoc.Declaration.ToString)

            Console.WriteLine(vbCrLf & "All Cars in file:" & vbCrLf)
            Dim query = From model In xmlDoc.Descendants("Model")
                        Select New With {.Name = model.Attribute("Name")}

            For Each c In query
                Console.WriteLine(c.Name)
            Next
            ''----------------------------

            'Console.WriteLine(vbCrLf & "All Cars in file:" & vbCrLf)
            'Dim query1 = From model In xmlDoc.Descendants("Model")
            '             Where model.DescendantsPower >= 100
            '            Select New With {.Name = model.Attribute("Name")}

            'For Each c In query1
            '    Console.WriteLine(c.Name)
            'Next


        Catch ex As Exception
            Console.WriteLine("Error: " & ex.Message)
        End Try

        Console.WriteLine(vbCrLf & "Hit Enter to exit.")
        Console.ReadLine()
    End Sub

End Module
