﻿Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary

Module GenericSerializer

    Public Sub SerializeToFile(Of T)(ByVal path As String, ByVal obj As T)
        Using fs As New FileStream(path, System.IO.FileMode.Create)
            Dim bf As New BinaryFormatter(Nothing, New StreamingContext(StreamingContextStates.File))
            bf.Serialize(fs, obj)
        End Using
    End Sub

    Public Function DeserializeFromFile(Of T)(ByVal path As String) As T
        Using fs As New FileStream(path, FileMode.Open)
            Dim bf As New BinaryFormatter(Nothing, New StreamingContext(StreamingContextStates.File))
            Return DirectCast(bf.Deserialize(fs), T)
        End Using
    End Function

End Module
