﻿Module Module1

    Const FILE As String = "Serialization.bin"

    Sub Main()
        'create a person object and serialize it to disc
        Dim p As New Person("Mustermann", "Max", 2000.0, #3/31/1990#)
        Console.WriteLine("Before serialization: ")
        Console.WriteLine(p.ToString)
        GenericSerializer.SerializeToFile(Of Person)(FILE, p)

        p = Nothing     'throw the person object away

        'deserialize a person object from disc
        p = GenericSerializer.DeserializeFromFile(Of Person)(FILE)
        GenericSerializer.SerializeToFile(Of Person)(FILE, p)
        Console.WriteLine("After deserialization: ")
        Console.WriteLine(p.ToString)

        Console.WriteLine("Hit Enter to exit.")
        Console.ReadLine()
    End Sub

End Module
