﻿Module Module1
    Dim myFirstCar As Car   'first we need a variable of type Car

    Sub Main()
        Try
            'set consolse window size
            Console.WindowWidth = 120

            'define a car

            myFirstCar = New Car(Car.CarManufacturer.Ferrari, "FF", "W-54321X", 300, 20.8) 'then we instantiate an object of class Car an assign it to the variable

            'define another car
            Dim mySecondCar As Car = New Car(Car.CarManufacturer.Lamborghini, "Miura", "K-4321Y", 200, 10.2) 'here we do all in one line

            'define my third car
            Dim myThirdCar = New Car(Car.CarManufacturer.Maserati, "GranCabrio Sport", "N-32154S", 300, 14.5) 'the compiler dedects from the right side of "=" that the variable on the left is oft type car

            'display a list of my cars
            Console.WriteLine(myFirstCar.ToString)
            Console.WriteLine(mySecondCar.ToString)
            Console.WriteLine(myThirdCar.ToString)

            'wire up event handlers
            AddHandler myFirstCar.NoFuel, AddressOf NoFuelLeft
            AddHandler myFirstCar.Speed, AddressOf SpeedReached

            'now let's drive the first car
            With myFirstCar
                .Accelerate(20)                 'accelerate to 20 km/h
                Threading.Thread.Sleep(5000)    'wait 5 secs
                .Accelerate(40)                 'accelerate to 40 km/h
                Threading.Thread.Sleep(5000)    'wait 5 secs
                .Accelerate(60)                 'accelerate to 60 km/h
                Threading.Thread.Sleep(5000)    'wait 5 secs
                .Accelerate(80)                 'accelerate to 80 km/h
                Threading.Thread.Sleep(5000)    'wait 5 secs
                .Accelerate(100)                 'accelerate to 100 km/h
                Threading.Thread.Sleep(5000)    'wait 5 secs
            End With

            'display the state of the car
            Console.WriteLine(myFirstCar.ToString)

            'dispose the cars and invalidate the variables
            myFirstCar.Dispose()
            myFirstCar = Nothing
            mySecondCar.Dispose()
            mySecondCar = Nothing
            myThirdCar.Dispose()
            myThirdCar = Nothing

        Catch ex As Exception
            Console.WriteLine("An error happened: " & ex.Message)
        End Try

        'prevent app from closing without user hitting any key
        Console.WriteLine(vbCrLf & "Hit any key to exit.")
        Console.ReadLine()


    End Sub

    Private Sub SpeedReached(speed As Integer)
        Console.WriteLine("Reached " & speed & " km/h. Fuel left: " & myFirstCar.Fuel & " l.")
    End Sub

    Private Sub NoFuelLeft()
        Console.WriteLine("We ran out of gas! Filling up 25 l ...")
        myFirstCar.Fuel = 25    'add 25 l fuel
    End Sub
End Module
