'TEST FR BUCH !!!
'ToDo: vgl mit XML kommentar der mSDN hilfe!!!
'ADD ist nicht gut bei RO List!!!

Module Module1

    Sub Main()
        Dim myLocomotives As New ReadOnlyList(Of Locomotive)(5, New Locomotive("Dorftrottel"), New Locomotive("BB 2050"))
        Dim myCars As New ReadOnlyList(Of Car)(3, New Car("Audi 100"), New Car("Porsche 911"), New Car("Mercedes CLK"))

        Console.WriteLine(myCars(2))
        Console.WriteLine(myCars.Item(2))

        Console.ReadLine()
    End Sub

    ''' <summary>
    ''' ReadOnlyList(Of T) provides data of type T
    ''' </summary>
    ''' <typeparam name="T"></typeparam>
    ''' <remarks></remarks>
    Public Class ReadOnlyList(Of T)
        Private mItems As List(Of T)    'list holding the items

        ''' <summary>
        ''' Creates ReadOnlyList with initial size
        ''' </summary>
        ''' <param name="elementCount">initial number of items</param>
        ''' <param name="values">Parameter array of items to load into list</param>
        ''' <remarks></remarks>
        Public Sub New(ByVal elementCount As Integer, ByVal ParamArray values() As T)
            mItems = New List(Of T)(elementCount)
            For Each v As T In values
                Me.Add(v)
            Next
        End Sub

        ''' <summary>
        ''' Number of items in list
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property Count() As Integer
            Get
                Return mItems.Count
            End Get
        End Property

        ''' <summary>
        ''' Add single item
        ''' </summary>
        ''' <param name="value"></param>
        ''' <remarks>
        ''' a value of Nothing is ignored</remarks>
        Private Sub Add(ByVal value As T)
            'note how we compare to Nothing:
            If Not Object.Equals(value, Nothing) Then
                mItems.Add(value)
            End If
        End Sub

        ''' <summary>
        ''' Return item at given index
        ''' </summary>
        ''' <param name="index"></param>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Default Public ReadOnly Property Item(ByVal index As Integer) As T
            Get
                Return mItems(index)
            End Get
        End Property
    End Class

    '---------------------------------------------
    'ab hier ist nur Info - kein ausfhrbarer Code
    '---------------------------------------------
    'Ntzliches:
    Public Class Scratch
        Public Sub Relation(Of T, V)(ByVal p1 As T, ByVal p2 As V)  'mehrere generic parameter

        End Sub

        'constraints
        '  x = max(12, 3, 7, 14, -1)
        Public Function Max(Of T As IComparable)(ByVal ParamArray values() As T) As T
            Dim result As T = values(0)
            For i As Integer = 1 To UBound(values)
                If result.CompareTo(values(i)) < 0 Then result = values(i)
            Next
            Return result
        End Function


    End Class



End Module
