'funktioniert

Imports School

Module Module1

    Const BINARY_OUTPUT_FILE As String = "C:\Temp\school.bin"
    Const XML_OUTPUT_FILE As String = "C:\Temp\school.xml"

    Sub Main()
        Console.Title = "ObjectModel School, V1.20, 20-Jan-2008, Herbert Feichtinger"
        Console.SetWindowSize(110, 58)

        'create the htl donaustadt (departments, grades, students)
        Dim s As School.School
        s = School.School.CreateSchoolTestData

        'output the whole object model
        'Console.WriteLine(s.ToString())

        '-------------------------------------------------------------------------------------------
        'SORT
        '-------------------------------------------------------------------------------------------

        'sort all students by class and ... and output them
        'Console.WriteLine(vbCrLf & "Students sorted by Dept., Class, Birthdate")
        's.SortStudentsByBirthdate()
        'Console.WriteLine(s.ToString())

        'Console.WriteLine(vbCrLf & "Students sorted by Dept., Class, Gender")
        's.SortStudentsByGender()
        'Console.WriteLine(s.ToString())

        'Console.WriteLine(vbcrlf & "Students sorted by Dept., Class, Sunsight")
        's.SortStudentsBySunSign()
        'Console.WriteLine(s.ToString())

        '-------------------------------------------------------------------------------------------
        'SERIALIZE
        '-------------------------------------------------------------------------------------------

        'binary serialize to file / deserialize from file
        s.SerializeBinary(BINARY_OUTPUT_FILE)
        s = Nothing
        s = School.School.DeserializeBinary(BINARY_OUTPUT_FILE)

        'XML serialize to file / deserialize from file
        's.SerializeXML(XML_OUTPUT_FILE)
        's = Nothing
        's = School.School.DeserializeXML(XML_OUTPUT_FILE)

        'output the whole object model
        Console.WriteLine(s.ToString())


        Console.ReadLine()
    End Sub

End Module
