﻿Imports System.Threading

Public Class Form1
    'STEP 1:
    Dim mTimer As System.Threading.Timer
    Dim mTickNext As Boolean = True

    'STEP 2:
    'Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    '    txtClock.Text = Date.Now.ToLongTimeString

    '    'use a statement lambda instead of a delegate to invoke the handler
    '    'and use another statement lambda to define the event handler "in-line"
    '    Dim mTimer As New System.Threading.Timer(callbackMethod,
    '                           Nothing, 1000, 1000)
    'End Sub

    'STEP 3:
    'Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    '    txtClock.Text = Date.Now.ToLongTimeString

    '    'use a statement lambda instead of a delegate to invoke the handler
    '    'and use another statement lambda to define the event handler "in-line"
    '    Dim mTimer As New System.Threading.Timer((Sub()
    '                                                  'TBD: code for UI access
    '                                                  'executing in worker thread
    '                                                  )
    '                                              End Sub),
    '                           Nothing, 1000, 1000)
    'End Sub

    'STEP 4:
    'Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    '    txtClock.Text = Date.Now.ToLongTimeString

    '    'use a statement lambda instead of a delegate to invoke the handler
    '    'and use another statement lambda to define the event handler "in-line"
    '    Dim mTimer As New System.Threading.Timer((Sub()
    '                                                  Me.Invoke(Sub()
    '                                                                'TBD: code for UI access
    '                                                                'executing in main thread
    '                                                            End Sub
    '                                                  )
    '                                              End Sub),
    '                           Nothing, 1000, 1000)
    'End Sub

    'STEP 5:
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtClock.Text = Date.Now.ToLongTimeString

        'use a statement lambda instead of a delegate to invoke the handler
        'and use another statement lambda to define the event handler "in-line"
        Dim mTimer As _
            New System.Threading.Timer( _
                (Sub()
                     Me.Invoke(Sub()
                                   txtClock.Text = Date.Now.ToLongTimeString
                                   If mTickNext Then
                                       Label1.Text = "Tick"
                                   Else
                                       Label1.Text = "Tock"
                                   End If
                                   mTickNext = Not mTickNext
                               End Sub
                     )
                 End Sub),
                 Nothing, 1000, 1000)
    End Sub
End Class
