﻿Module Module1

    Sub Main()
        'The three parts of a LINQ query:
        ' 1. Data source
        Dim numbers() As Integer = {0, 1, 2, 3, 4, 5, 6}

        ' 2. Query creation: obtain even numbers
        Dim numQuery = From num In numbers
                        Where ((num Mod 2) = 0)
                        Select num          'Select can be omitted in VB!

        ' 3. Query execution
        For Each num In numQuery
            Console.WriteLine(String.Format("{0,1}", num))
        Next

        Console.ReadLine()
    End Sub

End Module
