﻿Imports System.Runtime.Serialization.Formatters.Binary

<Serializable()> _
Public Class Person
    Public Sub New(name As String, firstName As String, salary As Decimal, birthDate As Date)
        Me.Name = name
        Me.FirstName = firstName
        Me.Salary = salary
        Me.BirthDate = birthDate
    End Sub

    Public Property FirstName() As String
    Public Property Name() As String
    Public Property Salary() As Decimal
    Public Property BirthDate() As Date

    Public Overrides Function ToString() As String
        Dim sb As New System.Text.StringBuilder
        sb.Append(Me.Name)
        sb.Append(", ")
        sb.Append(Me.FirstName)
        sb.Append(": born ")
        sb.Append(Me.BirthDate.ToShortDateString)
        sb.Append(". Earns: ")
        sb.AppendLine(String.Format("{0:c}", Me.Salary))
        Return sb.ToString
    End Function
End Class

'nur serialisiering in main
'ohne Serializable attribut schreiben
'mit serializable
'deserialisiernug dazu

